{******************************************************************************}
{                         Very Complete Progman Unit                           }
{                                  30-11-96                                    }
{                              Jeroen van Rooij                                }
{                            2:285/264.78@FidoNet                              }
{                            115:3100/1.4@PascalNet                            }
{                     Copyright (c) 1994 - 1996 Jeroen van Rooij               }
{                                 Units used:                                  }
{          DdeMan, SysUtils, Classes, Forms,  StrPlus (My own unit)            }
{******************************************************************************}
{Sorry, no documentation!

 Credit where credit is due...

 This unit is released as Freeware.  If you use it, you do so at your
 own risk. Feel free to modify this source code to suit your own purposes.
 If you enhance this unit, I'd like to see your work.

 Houdoe...

 }

{$S-}
unit Progman;

interface
{
 Development Notes:


}

uses
  DdeMan,SysUtils, Classes, StrPlus, Forms;

Type
  TGroup = (tgCreate , tgActivate, tgDelete, tgReload, tgIconize,
            tgMaximize, tgMinimize);

  TItem  = (tiDelete, tiCreate,tiReplace);

  TItemInfo = Record
                Name: string;
                CmdLine: string;
                DefDir: string;
                IconPath:string;
                Xpos,
                Ypos: integer;
                IconIndex: integer;
                HotKey : integer;
                fMinimize: boolean;
               end;

TGroupInfo = Record
              GroupName: string;
              GroupPath: string;
              Items: Integer;
             end;

procedure InitPM;                          {initialize PM. Use it on OnActivate}
procedure ClosePM;                         {Close PM. Use it on OnClose        }


{Install function}
function ItemAction(ItemName:string;ItemType: TItem): boolean;
function GroupAction(GroupName:string; GroupType: TGroup): boolean;
function AddItem(Group:string;Item: TItemInfo) : Boolean;


{Info procedures}
procedure GetGroups(Var s: TStringList);               {Get the Progman groups}
procedure GetItems(Group: string; var s: TStringList); {and get the items     }

{Parsing procedures}
procedure ParseGroup(Group: string; Var GroupInfo: TGroupInfo);
procedure ParseItem(Item:string; Var ItemInfo:TItemInfo);



implementation

var
  DDEClient : TDdeClientConv;

function BoolToInt(Bool: Boolean): integer;
begin
Case Bool of
True  : Result:=1;
False : Result:=0;
end;
end;

procedure initPM;
begin
 DDeClient:=TDdeClientConv.Create(Application);
 DDeClient.SetLink('Progman','Progman');
 DDeClient.OpenLink;
end;


procedure ClosePM;
begin
 DDeClient.CloseLink;
end;


procedure GetGroups(Var s: TStringList);
begin
  s.SetText(DDeClient.RequestData('Groups'));
end;

Procedure GetItems(Group: string; var s: TStringList);
begin
  s.SetText(DDeClient.RequestData(Group));
end;

function GroupAction(GroupName:string; GroupType: TGroup): boolean;
var
  pCmd : array[0..255] of char;
  FormatStr: String;
begin
 Case GroupType of
 tgCreate       : FormatStr:='[CreateGroup(%s)]';
 tgActivate     : FormatStr:='[ShowGroup(%s,1)]';
 tgDelete       : FormatStr:='[DeleteGroup(%s)]';
 tgReload       : FormatStr:='[ReloadGroup(%s)]'; {Only in win 3.1}
 tgIconize      : FormatStr:='[ShowGroup(%s,2)]';
 tgMaximize     : FormatStr:='[ShowGroup(%s,3)]';
 tgMinimize     : FormatStr:='[ShowGroup(%s,6)]';
 End;{Case}
  try
   StrPCopy (pCmd, Format(FormatStr, [GroupName]) + #13#10);
   Result := DDEClient.ExecuteMacro(pCmd, False);
  except
   Result := False;
  end;{Try}
end;


function ItemAction(ItemName:string;ItemType: TItem): boolean;
var
  pCmd : array[0..255] of char;
  FormatStr: String;
begin
  Case ItemType of
  tiDelete      : FormatStr:='[DeleteItem(%s)]'; {Only in win 3.1}
  tiCreate      : FormatStr:='[AddItem(%s)]';
  tiReplace     :FormatStr:='[ReplaceItem(%s)]';
  end;
  try
    StrPCopy (pCmd, Format(FormatStr, [ItemName]) + #13#10);
    Result := DDEClient.ExecuteMacro(pCmd, False);
  except
    Result := False;
  end; {try}
end;

function AddItem(Group:string;Item: TItemInfo) : Boolean;
begin
 try
  GroupAction(Group,tgActivate);
  ItemAction(Item.Name,tiReplace);
  Result:=ItemAction(Item.CmdLine+','+
                     Item.Name+','+
                     Item.IconPath+','+
                     IntToStr(Item.IconIndex)+','+
                     IntToStr(Item.Xpos)+','+
                     IntToStr(Item.Ypos)+','+
                     Item.DefDir+','+
                     IntToStr(Item.HotKey)+','+
                     IntToStr(BoolToInt(Item.fMinimize)),tiCreate);
  GroupAction(Group,tgActivate);
 except
  Result:=false;
 end;
end;

procedure ParseGroup(Group: string; Var GroupInfo: TGroupInfo);
var p: integer;
    temp,
    extract: string;
begin
    temp:=Group;
    temp:=Replace(',',' ,',temp);
   for p:=1 to ItemCount(Temp,[',']) do
     begin
      extract:=ExtractItem(temp,p,[',']);
      Case p of
      1:GroupInfo.GroupName:=KillChars(Extract,['"',',']);
      2:GroupInfo.GroupPath:=KillChars(Extract,['"',',']);
      3:GroupInfo.Items:=StrToInt(KillChars(Extract,['"',',']));
      end;
     end;
end;

procedure ParseItem(Item:string; Var ItemInfo:TItemInfo);
var p: integer;
    temp,
    extract: string;
begin
    temp:=Item;
    temp:=Replace(',',' ,',temp);
    for p:=1 to ItemCount(Temp,[',']) do
     begin
     extract:=ExtractItem(temp,p,[',']);
     case p of
      1  : ItemInfo.Name:=KillChars(Extract,['"',',']);
      2  : ItemInfo.CmdLine:=KillChars(Extract,['"',',']);
      3  : begin
             ItemInfo.DefDir:=KillChars(Extract,['"',',']);
             If AllTrim(ItemInfo.DefDir)=''then
                ItemInfo.DefDir:=ExtractFilePath(ExtractItem(ItemInfo.CmdLine,1,[' ']));
           end;
      4  : begin
             ItemInfo.IconPath:=ExtractItem(KillChars(Extract,['"',',']),1,[' ']);
             if AllTrim(ItemInfo.IconPath)='' then
                ItemInfo.IconPath:=ExtractFilePath(ExtractItem(ItemInfo.CmdLine,1,[' ']));
           end;
      5  : ItemInfo.Xpos:=StrToInt(AllTrim(KillChars(Extract,[','])));
      6  : ItemInfo.Ypos:=StrToInt(AllTrim(KillChars(Extract,[','])));
      7  : ItemInfo.IconIndex:=StrToInt(AllTrim(KillChars(Extract,[','])));
      8  : ItemInfo.HotKey:=StrToInt(AllTrim(KillChars(Extract,[','])));
      9  : ItemInfo.fMinimize:=(StrToInt(AllTrim(KillChars(Extract,[','])))<> 0);
     end;
    end;
end;



end.

