{******************************************************************************}
{                              Jeroen van Rooij                                }
{                            2:285/264.78@FidoNet                              }
{                            115:3100/1.4@PascalNet                            }
{                     Copyright (c) 1994 - 1996 Jeroen van Rooij               }
{******************************************************************************}
{Sorry, no documentation!

 Credit where credit is due...

 This unit is released as Freeware.  If you use it, you do so at your
 own risk. Feel free to modify this source code to suit your own purposes.
 If you enhance this unit, I'd like to see your work.

 Houdoe...

 }


unit StrPlus;

interface
{
 Development Notes:


}


Uses SysUtils;

type
    TCharSet = Set Of Char;

function before(const s, Find: string): string;
function after(const s, Find: string): string;
function reverse(const Search: string): string;
function RightPos(const Find, S: string): byte;
function ItemCount(const S: string; const sep: TCharSet): Byte;
function ExtractItem(Const S: String; N: Byte; const Sep: TCharSet): String;
function GetFirstPos(const S: string; const Find: TCharset): byte;
function GetLastPos(const S: string; const Find: TCharset): byte;
function Contains(const Find, S: String; MatchCase: boolean): Boolean;
function WildCardContains(const Find, s: String): Boolean;

function Replace (S: string; const Old, New: string): string;
function Inside(const S, FirstStr, LastStr: string): string;
function leftside(const S, FirstStr, LastStr: string): string;
function rightside(const S, FirstStr, LastStr: string): string;

function LTrim(s: string): string;
function RTrim(s: string): string;
function AllTrim(s: string): string;
function KillChars(const s: string; C: TCharSet): string;

function FormatNumber(Int: longint): string;
function LeadZero(const Int, len:integer): string;


function PosWord(N: byte; S:string): byte;
function WordCnt(S: string): byte;
function ExtractWords(StartWord, NoWords: byte; Str:string): string;
function Capitalize(const S: String): String;
function Soundex(const S: String): String;
function Encrypt(const S: String; Key: Word): String;
function Decrypt(const S: String; Key: Word): String;
function CodeToChar(S: string; Sep: TCharSet): string;

implementation

const   NULL            =  '';
        BACKSPACE       =  #8;
        TAB             =  #9;
        LF              = #10;
        CR              = #13;
        EOF_            = #26;
        ESC             = #27;
        BLANK           = #32;
        SPACE           = BLANK;

        C1              = 52845;
        C2              = 22719;



function before(const s, Find: string): string;
var
  index: byte;
begin
  index:=Pos(Find, s);
  if index = 0 then
    Result:=s
  else
    Result:=Copy(s, 1, index - 1);
end;

function after(const s, Find: string): string;
var
  index: byte;
begin
  index:=Pos(Find, s);
  if index = 0 then
    Result:=Null
  else
    Result:=Copy(s, index + Length(Find), 255);
end;

function reverse(const Search: string): string;
var
  Index: byte;
begin
  Result:=Null;
  for Index:=Length(Search) downto 1 do
    AppendStr(Result, Search[Index]);
end;

function RightPos(const Find, S: string): byte;
begin
  Result:=Pos(reverse(Find), reverse(S));
  if Result > 0 then
    Result:=Length(S) - Result + 1;
end;

function GetFirstPos(const S: string; const Find: TCharset): byte;
begin
  for Result:=1 to Length(S) do
    if S[Result] in Find then
      Exit;
  Result:=0;
end;

function GetLastPos(const S: string; const Find: TCharset): byte;
begin
  for Result:=Length(S) downto 1 do
    if S[Result] in Find then
      Exit;
  Result:=0;
end;

function Contains(const Find, S: String; MatchCase: boolean): Boolean;
begin
 if not MatchCase then
          Result:=Pos(AnsiUppercase(find),AnsiUppercase(s)) > 0
    else
          Result:=Pos(find,s) > 0

end;


function Replace (S: string; const Old, New: string): string;
var
Tmp: string;
Posn: Integer;
Begin
   If Length(Old) > 0 then begin
      Tmp := '';
      repeat
      Posn := Pos(Old, S);
      If Posn > 0 then begin
         Tmp := Tmp + Copy(S, 1, Posn - 1) + New;
         Delete(S, 1, Posn + Length(Old) - 1);
      End
      Else
      Tmp := Tmp + S;
      Until Posn = 0;
      Result := Tmp;
   end
   else
   Result := S;
End;


function Inside(const S, FirstStr, LastStr: string): string;
var
  Index, Len: byte;
begin
  Len:=Pos(LastStr, S);
  Result:=Null;
  if Len > 0 then
  begin
    Index:=RightPos(FirstStr, Copy(S, 1, Len - 1));
    if Index > 0 then
      Result:=Copy(S, Index + Length(FirstStr), Len - Index - Length(FirstStr));
  end;
end;

function leftside(const S, FirstStr, LastStr: string): string;
var
  Index, Len: byte;
begin
  Result:=S;
  Len:=Pos(LastStr, S);
  if Len > 0 then
  begin
    Index:=RightPos(FirstStr, Copy(S, 1, Len - 1));
    if Index > 0 then
      Result:=Copy(S, 1, Index - 1);
  end;
end;

function rightside(const S, FirstStr, LastStr: string): string;
var
  Index, Len: byte;
begin
  Result:=Null;
  Len:=Pos(LastStr, S);
  if Len > 0 then
  begin
    Index:=RightPos(FirstStr, Copy(S, 1, Len - 1));
    if Index > 0 then
      Result:=Copy(S, Len + Length(LastStr), 255);
  end;
end;

function  ItemCount(const S: string; const Sep: TCharSet): Byte;
var
i,Count,Len : Byte;
begin
   Count:=0; i:=1;
   Len:=Length(S);
   while i<=Len do begin
     While (i<=Len) and (S[i] in Sep) do inc(i);
      If i<=Len then inc(Count);
     While (i<=Len) and not(S[i] in Sep) do inc(i);
   end;
   ItemCount:=Count;
end;

function WildCardContains(const Find, s: String): Boolean;
{Found in Loyd's Delphi}
var
  pSource: Array [0..255] of Char;
  pPattern: Array [0..255] of Char;

function MatchPattern(element, pattern: PChar): Boolean;
function IsPatternWild(pattern: PChar): Boolean;
var
  t: Integer;
begin
  Result := StrScan(pattern,'*') <> nil;
  if not Result then Result := StrScan(pattern,'?') <> nil;
end;
begin
  if 0 = StrComp(pattern,'*') then
    Result := True
  else if (element^ = Chr(0)) and (pattern^ <> Chr(0)) then
    Result := False
  else if element^ = Chr(0) then
    Result := True
  else begin
    case pattern^ of
    '*': if MatchPattern(element,@pattern[1]) then
           Result := True
         else
           Result := MatchPattern(@element[1],pattern);
    '?': Result := MatchPattern(@element[1],@pattern[1]);
    else
      if element^ = pattern^ then
        Result := MatchPattern(@element[1],@pattern[1])
      else
        Result := False;
    end;
  end;
end;

begin
  StrPCopy(pSource,s);
  StrPCopy(pPattern,find);
  Result := MatchPattern(pSource,pPattern);
end;

function  ExtractItem(Const S: String; N: Byte; const Sep: TCharSet): String;
Var
i, Count, Len : Byte;
Extract       : String;
Begin
   Count:=0; i:=1;
   Len:=Length(S);
   Extract:='';
   While (i<=Len) and (Count<>N) do begin
      While (i<=Len) and (S[i] IN Sep) do inc(i);
      If i<=Len then inc(Count);
      While (i<=Len) and not(S[i] in Sep) do begin
         If Count=N then
         Extract:=Extract+S[i];
         Inc(I);
      End;
   End;
   Result:=Extract;
End;

function LTrim(s: string): string;
var i: integer;
begin
  i := 1;
  while s[i] = ' ' do inc(i);
  result := copy(s, i, length(s) - i + 1);
end;

function RTrim(s: string): string;
begin
  while s[length(s)] = ' ' do dec(s[0]);
  result := s;
end;

function AllTrim(s: string): string;
begin
  result := rTrim(lTrim(s));
end;


function KillChars(const s: string; C: TCharSet): string;
var i: integer;
    t: string;
begin
 t:='';
 for i:=1 to length(s) do
    if not (s[i] in c) then t:=t+s[i];

 Result:=t;
end;

function FormatNumber(Int: longint): string;
begin
  Result := FormatFloat('#,##0', StrToFloat(IntToStr(Int)));
end;

function LeadZero(const Int, len:integer): string;
begin
 Result:=Format('%.'+IntToStr(len)+'d',[int]);
end;

function LocWord(StartAT,Wordno:byte;Str:string):byte;
var
  W,L: integer;
  Spacebefore: boolean;
begin
   if (Str = '') or (wordno < 1) or (StartAT > length(Str)) then
   begin
       LocWord := 0;
       exit;
   end;
   SpaceBefore := true;
   W := 0;
   L := length(Str);
   StartAT := pred(StartAT);
   while (W < Wordno) and (StartAT <= length(Str)) do
   begin
      StartAT := succ(StartAT);
      if SpaceBefore and (Str[StartAT] <> ' ') then
      begin
         W := succ(W);
         SpaceBefore := false;
      end
      else
         if (SpaceBefore = false) and (Str[StartAT] = ' ') then
            SpaceBefore := true;
   end;
   if W = Wordno then
      LocWord := StartAT
   else
      LocWord := 0;
end;

function PosWord(N: byte; S:string): byte;
begin
   result := LocWord(1,N,S);
end;

function WordCnt(S: string): byte;
var
  W,I: integer;
  SpaceBefore: boolean;
begin
   if S = '' then
   begin
      Result := 0;
      exit;
   end;
   SpaceBefore := true;
   W := 0;
   For  I :=  1 to length(S) do
   begin
      if SpaceBefore and (S[I] <> ' ') then
      begin
         W := succ(W);
         SpaceBefore := false;
      end
      else
         if (SpaceBefore = false) and (S[I] = ' ') then
            SpaceBefore := true;
   end;
   Result := W;
end;

function ExtractWords(StartWord, NoWords: byte; Str:string): string;
var Start, finish : integer;
begin
   if Str = '' then
   begin
      Result := '';
      exit;
   end;
   Start := LocWord(1,StartWord,Str);
   if Start <> 0 then
      finish := LocWord(Start,succ(NoWords),Str)
   else
   begin
      Result:= '';
      exit;
   end;
   if finish = 0 then
      finish := succ(length(Str));
   repeat
      finish := pred(finish);
   until Str[finish] <> ' ';
   Result := copy(Str,Start,succ(finish-Start));
end;

function Soundex(Const S: String): String;
const
  CvTable : array['B'..'Z'] of char = (
    '1', '2', '3', '0', '1',   {'B' .. 'F'}
    '2', '0', '0', '2', '2',   {'G' .. 'K'}
    '4', '5', '5', '0', '1',   {'L' .. 'P'}
    '2', '6', '2', '3', '0',   {'Q' .. 'U'}
    '1', '0', '2', '0', '2' ); {'V' .. 'Z'}
var
  i,j : Integer;
  aGroup,Ch  : Char;
  tmp: string;
  function Group(Ch: Char): Char;
  begin
    if (Ch in ['B' .. 'Z']) and not (Ch In ['E','H','I','O','U','W','Y']) then
       Result:=CvTable[Ch]
    else
       Result:='0';
  end;

begin
  Result := '000';
  if S='' then exit;

  tmp:= AnsiUpperCase(S);
  i:= 2;
  j:= 1;
  while (i <= Length(tmp)) and ( j<=3) do
  begin
    Ch := tmp[i];
    aGroup := Group(Ch);
    if (aGroup <> '0') and (Ch <> tmp[i-1]) and
       ((J=1) or (aGroup <> Result[j-1])) and
       ((i>2) or (aGroup <> Group(tmp[1]))) then
    begin
      Result[j] :=aGroup;
      Inc(j);
    end;
    Inc(i);
  end; {while}
  Result:=tmp[1]+'-'+Result;
end;

function Encrypt(const S: String; Key: Word): String;
var
  I: Integer;
begin
   Result[0]:=Chr(Length(S));
  for I := 1 to Length(S) do begin
    Result[I] := Char(Ord(S[I]) xor (Key shr 8));
    Key := (Ord(Result[I]) + Key) * C1 + C2;
  end;
end;

function Decrypt(const S: String; Key: Word): String;
var
  I: Integer;
begin
   Result[0]:=Chr(Length(S));
  for I := 1 to Length(S) do begin
    Result[I] := char(Ord(S[I]) xor (Key shr 8));
    Key := (Ord(S[I]) + Key) * C1 + C2;
  end;
end;

function Capitalize(const S: String): String;
var
  i      : Integer;
  Ch     : Char;
  First  : Boolean;
begin
  First  := True;
  Result := '';
  for i:=1 to Length(S) do
  begin
    Ch:=S[i];
    if Ch in [SPACE,'-','.'] then
       First:=True
    else if First then
    begin
      Ch:=AnsiUpperCase(Ch)[1];
      First:=False;
    end;
    Result:=Result+Ch;
  end;
end;

function CodeToChar(S: string; Sep: TCharSet): string;
var
  i: integer;
  Temp: string;
begin
 Temp:='';
 for i:=1 to ItemCount(s,Sep) do
 temp:=Temp+Chr(StrToInt(ExtractItem(s,i,Sep)));
 Result:=Temp;

end;


end.
